/*
 *
 *
 */
#ifndef __TDM_MODULE_H__
#define __TDM_MODULE_H__

/**
 * Definition of module
 */
struct tdm_module_def {
	const char *name;
	const char *description;

	/* module ops */
	tdm_status_t (* module_load)(struct tdm_module *mod);		/*!< invoked after loading */
	tdm_status_t (* module_unload)(struct tdm_module *mod);		/*!< invoked before unloading */
	tdm_status_t (* module_probe)(struct tdm_module *mod);		/*!< device auto-detection */
	tdm_status_t (* module_configure)(struct tdm_module *mod);	/*!< module configuration / manual device registraion */
};

/**
 * "Internal" module handle
 */
struct tdm_module {
	struct tdm_object obj;

	struct tdm_module_def *def;	/*!< module definition + ops */

	struct dlist_head     module_list;
};

/* add module to global list, after successfull load + init */
tdm_status_t tdm_module_add(struct tdm_module *mod);


#endif /* __TDM_MODULE_H__ */
