/*
 *
 *
 */
#ifndef __TDM_SPANGROUP_H__
#define __TDM_SPANGROUP_H__

struct tdm_spangroup {
	struct tdm_object obj;

	struct tdm_policy  *policy;	/*!< policy for this group */

	unsigned int       nr_spans;
	struct dlist_head  spans;

	void *priv;			/*!< custom data for policy */
};

void tdm_spangroup_set_private(struct tdm_spangroup *group, void *data);
void *tdm_spangroup_get_private(struct tdm_spangroup *group);

struct tdm_spangroup *tdm_spangroup_new(const char *name);

int tdm_spangroup_has_span(struct tdm_spangroup *group, struct tdm_span *span);
tdm_status_t tdm_spangroup_add_span(struct tdm_spangroup *group, struct tdm_span *span);
tdm_status_t tdm_spangroup_remove_span(struct tdm_spangroup *group, struct tdm_span *span);

#endif /* __TDM_SPANGROUP_H__ */
