/*
 * libtdm module api
 *
 */
#ifndef _TDM_MODULE_H_
#define _TDM_MODULE_H_

/**
 * Module definition (api, only visible part of a module, const)
 */
struct tdm_module_handle;

struct tdm_module {
	/* Common */
	const char *name;
	tdm_status_t (*init)(const struct tdm_module_handle *mod);	/*!< Module init */
	tdm_status_t (*fini)(const struct tdm_module_handle *mod);	/*!< Module exit */
	tdm_status_t (*reload)(const struct tdm_module_handle *mod);	/*!< Re-init module */

	/* I/O Module-specific  */
	tdm_status_t (*probe)(const struct tdm_module_handle *mod);	/*!< I/O modules only: detect hardware */

	/* SIG Module-specific */
};

tdm_status_t tdm_load_modules(void);

#endif /* _TDM_MOGULE_H_ */
